/* ---------------------------------------------------- */
/*  Generated by Enterprise Architect Version 13.5 		*/
/*  Created On : 28-Aug-2018 1:47:56 AM 				*/
/*  DBMS       : Oracle 						*/
/* ---------------------------------------------------- */

/* Drop Tables */

begin
	EXECUTE IMMEDIATE 'DROP TABLE   "sdc_intg_audit_log" CASCADE CONSTRAINTS';
	EXCEPTION WHEN OTHERS THEN NULL;
end;  
/

/* Create Tables */

CREATE TABLE  "sdc_intg_audit_log"
(
	"AUDIT_KEY" VARCHAR2(255) NOT NULL,
	"AUDIT_TS" TIMESTAMP(6) DEFAULT systimestamp NOT NULL,
	"AUDIT_ID" VARCHAR2(4) NOT NULL,
	"JURISDICTION" VARCHAR2(10) NOT NULL,
	"BUSINESS_DATE" DATE NOT NULL,
	"FILE_NAME" VARCHAR2(255) NOT NULL,
	"FILE_ARRIVAL_TIME" TIMESTAMP(6) NULL,
	"NON_REPUDIATION" CHAR(1) NULL,
	"DUP_CHECK" CHAR(1) NULL,
	"GAP_CHECK" CHAR(1) NULL,
	"VOLUME_CHECK" CHAR(1) NULL,
	"RECON_CHECK" CHAR(1) NULL,
	"SCHEMA_CHECK" CHAR(1) NULL,
	"MESSAGE_DIGEST_SOURCE" VARCHAR2(255) NULL,
	"MESSAGE_DIGEST_TARGET" VARCHAR2(255) NULL,
	"RECORD_COUNT" NUMBER(10) NULL,
	"HEADER_COUNT" NUMBER(10) NULL,
	"TOTAL_TX_AMOUNT" NUMBER(38,2) NULL,
	"CURRENCY" CHAR(3) NULL,
	"HEADER_AMOUNT" NUMBER(10) NULL,
	"SEND_COUNT" NUMBER(10) NULL,
	"RECEIVE_COUNT" NUMBER(10) NULL
)
;

/* Create Comments, Sequences and Triggers for Autonumber Columns */

COMMENT ON TABLE  "sdc_intg_audit_log" IS 'Staging Table for Integrity Check Auditing'
;

/* Create Primary Keys, Indexes, Uniques, Checks, Triggers */

ALTER TABLE  "sdc_intg_audit_log" 
 ADD CONSTRAINT "PK_SDC_CMPL_AUDIT_LOG"
	PRIMARY KEY ("AUDIT_KEY") 
 USING INDEX
;

/* Create Foreign Key Constraints */

ALTER TABLE  "sdc_intg_audit_log" 
 ADD CONSTRAINT "FK_sdc_intg_aud_sdc_cmpl_au_01"
	FOREIGN KEY ("AUDIT_KEY") REFERENCES  "sdc_cmpl_audit_log" ("AUDIT_KEY")
;

/* ---------------------------------------------------- */
/*  Generated by Enterprise Architect Version 13.5 		*/
/*  Created On : 28-Aug-2018 1:50:03 AM 				*/
/*  DBMS       : Oracle 						*/
/* ---------------------------------------------------- */

/* Drop Tables */

begin
	EXECUTE IMMEDIATE 'DROP TABLE   "sdc_cmpl_audit_log" CASCADE CONSTRAINTS';
	EXCEPTION WHEN OTHERS THEN NULL;
end;  
/

/* Create Tables */

CREATE TABLE  "sdc_cmpl_audit_log"
(
	"AUDIT_KEY" VARCHAR2(255) NOT NULL,
	"AUDIT_TS" TIMESTAMP(6) DEFAULT systimestamp NOT NULL,
	"AUDIT_ID" VARCHAR2(4) NOT NULL,
	"JURISDICTION" VARCHAR2(10) NOT NULL,
	"BUSINESS_DATE" DATE NOT NULL,
	"FILE_NAME" VARCHAR2(255) NOT NULL,
	"FILE_ARRIVAL_TIME" TIMESTAMP(6) NULL,
	"D1" NUMBER(10) NULL,
	"D2" NUMBER(10) NULL,
	"D3" NUMBER(10) NULL,
	"D4" NUMBER(10) NULL,
	"D5" NUMBER(10) NULL,
	"D6" NUMBER(10) NULL,
	"D7" NUMBER(10) NULL,
	"D8" NUMBER(10) NULL,
	"D9" NUMBER(10) NULL,
	"D10" NUMBER(10) NULL,
	"D11" NUMBER(10) NULL,
	"D12" NUMBER(10) NULL,
	"D13" NUMBER(10) NULL,
	"D14" TIMESTAMP(6) NULL,
	"D15" TIMESTAMP(6) NULL,
	"D16" VARCHAR2(255) NULL,
	"D17" VARCHAR2(255) NULL,
	"D18" VARCHAR2(255) NULL,
	"D19" VARCHAR2(255) NULL,
	"D20" VARCHAR2(255) NULL,
	"SOURCE_ID" VARCHAR2(3) NULL,
	"DIMENSION_ID" VARCHAR2(3) NULL
)
;

/* Create Comments, Sequences and Triggers for Autonumber Columns */

COMMENT ON TABLE  "sdc_cmpl_audit_log" IS 'Staging Table for Completeness Control Audits'
;

/* Create Primary Keys, Indexes, Uniques, Checks, Triggers */

ALTER TABLE  "sdc_cmpl_audit_log" 
 ADD CONSTRAINT "PK_SDC_CMPL_AUDIT_LOG"
	PRIMARY KEY ("AUDIT_KEY") 
 USING INDEX
;

/* Create Foreign Key Constraints */

ALTER TABLE  "sdc_cmpl_audit_log" 
 ADD CONSTRAINT "FK_sdc_cmpl_aud_sdc_flex_me_01"
	FOREIGN KEY ("AUDIT_ID","DIMENSION_ID") REFERENCES  "sdc_flex_measures" ("AUDIT_ID","DIMENSION_ID")
;

/* ---------------------------------------------------- */
/*  Generated by Enterprise Architect Version 13.5 		*/
/*  Created On : 28-Aug-2018 1:51:20 AM 				*/
/*  DBMS       : Oracle 						*/
/* ---------------------------------------------------- */

/* Drop Tables */

begin
	EXECUTE IMMEDIATE 'DROP TABLE   "sdc_flex_measures" CASCADE CONSTRAINTS';
	EXCEPTION WHEN OTHERS THEN NULL;
end;  
/

/* Create Tables */

CREATE TABLE  "sdc_flex_measures"
(
	"AUDIT_ID" VARCHAR2(4) NOT NULL,
	"DIMENSION_ID" VARCHAR2(3) NOT NULL,
	"MEASURE_NAME" VARCHAR2(255) NOT NULL,
	"MEASURE_DESC" VARCHAR2(255) NULL
)
;

/* Create Primary Keys, Indexes, Uniques, Checks, Triggers */

ALTER TABLE  "sdc_flex_measures" 
 ADD CONSTRAINT "PK_sdc_flex_measures"
	PRIMARY KEY ("AUDIT_ID","DIMENSION_ID") 
 USING INDEX
;

/* ---------------------------------------------------- */
/*  Generated by Enterprise Architect Version 13.5 		*/
/*  Created On : 28-Aug-2018 1:52:30 AM 				*/
/*  DBMS       : Oracle 						*/
/* ---------------------------------------------------- */

/* Drop Tables */

begin
	EXECUTE IMMEDIATE 'DROP TABLE   "sdc_ca_sources" CASCADE CONSTRAINTS';
	EXCEPTION WHEN OTHERS THEN NULL;
end;  
/

/* Create Tables */

CREATE TABLE  "sdc_ca_sources"
(
	"AUDIT_ID" VARCHAR2(4) NOT NULL,
	"SOURCE_NAME" VARCHAR2(255) NOT NULL,
	"FILE_SET_NAME" VARCHAR2(255) NOT NULL,
	"SOURCE_NARID" VARCHAR2(50) NOT NULL,
	"TARGET_NARID" VARCHAR2(50) NOT NULL,
	"CREATOR" VARCHAR2(10) NULL,
	"CREATED_ON" TIMESTAMP(6) NULL
)
;

/* Create Primary Keys, Indexes, Uniques, Checks, Triggers */

ALTER TABLE  "sdc_ca_sources" 
 ADD CONSTRAINT "PK_sdc_ca_sources"
	PRIMARY KEY ("AUDIT_ID") 
 USING INDEX
;

/* ---------------------------------------------------- */
/*  Generated by Enterprise Architect Version 13.5 		*/
/*  Created On : 28-Aug-2018 1:54:19 AM 				*/
/*  DBMS       : Oracle 						*/
/* ---------------------------------------------------- */

/* Drop Tables */

begin
	EXECUTE IMMEDIATE 'DROP TABLE   "sdc_ca_acl" CASCADE CONSTRAINTS';
	EXCEPTION WHEN OTHERS THEN NULL;
end;  
/

/* Create Tables */

CREATE TABLE  "sdc_ca_acl"
(
	"USER_ID" VARCHAR2(10) NOT NULL,
	"SOURCE_NARID" VARCHAR2(50) NOT NULL,
	"USER_NAME" VARCHAR2(50) NULL,
	"ORG_UNIT" VARCHAR2(255) NULL,
	"PERMISSION" VARCHAR2(3) NULL
)
;

/* Create Primary Keys, Indexes, Uniques, Checks, Triggers */

ALTER TABLE  "sdc_ca_acl" 
 ADD CONSTRAINT "PK_sdc_ca_acl"
	PRIMARY KEY ("USER_ID") 
 USING INDEX
;
