/* ---------------------------------------------------- */
/*  Generated by Enterprise Architect Version 13.5 		*/
/*  Created On : 14-Sep-2018 1:34:10 PM 				*/
/*  DBMS       : Oracle 						        */
/* ---------------------------------------------------- */

/* Drop Tables */

begin
	EXECUTE IMMEDIATE 'DROP TABLE   "SDC_INTG_AUDIT_LOG" CASCADE CONSTRAINTS';
	EXCEPTION WHEN OTHERS THEN NULL;
end;  
/

/* Create Tables */

CREATE TABLE  "SDC_INTG_AUDIT_LOG"
(
	"AUDIT_KEY" VARCHAR2(255) NOT NULL,
	"AUDIT_TS" TIMESTAMP(6) DEFAULT systimestamp NOT NULL,
	"AUDIT_ID" VARCHAR2(50) NOT NULL,
	"JURISDICTION" VARCHAR2(10) NOT NULL,
	"BUSINESS_DATE" DATE NOT NULL,
	"DATA_ELEMENT_NAME" VARCHAR2(255) NOT NULL,
	"IS_PRIMARY" CHAR(1) NOT NULL,
	"DATA_ARRIVAL_TIME" TIMESTAMP(6) NULL,
	"NON_REPUDIATION" CHAR(1) NULL,
	"DUP_CHECK" CHAR(1) NULL,
	"GAP_CHECK" CHAR(1) NULL,
	"VOLUME_CHECK" CHAR(1) NULL,
	"RECON_CHECK" CHAR(1) NULL,
	"SCHEMA_CHECK" CHAR(1) NULL,
	"MESSAGE_DIGEST_SOURCE" VARCHAR2(255) NULL,
	"MESSAGE_DIGEST_TARGET" VARCHAR2(255) NULL,
	"RECORD_COUNT" NUMBER(10) NULL,
	"HEADER_COUNT" NUMBER(10) NULL,
	"TOTAL_TX_AMOUNT" NUMBER(38,2) NULL,
	"CURRENCY" CHAR(3) NULL,
	"HEADER_AMOUNT" NUMBER(10) NULL,
	"SEND_COUNT" NUMBER(10) NULL,
	"RECEIVE_COUNT" NUMBER(10) NULL
)
;

/* Create Comments, Sequences and Triggers for Autonumber Columns */

COMMENT ON TABLE  "SDC_INTG_AUDIT_LOG" IS 'Staging Table for Integrity Check Auditing'
;

/* Create Primary Keys, Indexes, Uniques, Checks, Triggers */

ALTER TABLE  "SDC_INTG_AUDIT_LOG" 
 ADD CONSTRAINT "PK_SDC_INTG_AUDIT_LOG"
	PRIMARY KEY ("AUDIT_KEY") 
 USING INDEX
;

/* ---------------------------------------------------- */
/*  Generated by Enterprise Architect Version 13.5 		*/
/*  Created On : 19-Sep-2018 5:14:17 PM 				*/
/*  DBMS       : Oracle 						*/
/* ---------------------------------------------------- */

/* Drop Tables */

begin
	EXECUTE IMMEDIATE 'DROP TABLE   "SDC_CMPL_AUDIT_LOG" CASCADE CONSTRAINTS';
	EXCEPTION WHEN OTHERS THEN NULL;
end;  
/

/* Create Tables */

CREATE TABLE  "SDC_CMPL_AUDIT_LOG"
(
	"AUDIT_KEY" VARCHAR2(255) NOT NULL,
	"AUDIT_TS" TIMESTAMP(6) DEFAULT systimestamp NOT NULL,
	"AUDIT_ID" VARCHAR2(50) NOT NULL,
	"JURISDICTION" VARCHAR2(10) NOT NULL,
	"BUSINESS_DATE" DATE NOT NULL,
	"DATA_ELEMENT_NAME" VARCHAR2(255) NOT NULL,
	"IS_PRIMARY" CHAR(1) NOT NULL,
	"DATA_ARRIVAL_TIME" TIMESTAMP(6) NULL,
	"RECON_CHECK" CHAR(1) NOT NULL,
	"D1" NUMBER(18,2) NULL,
	"D2" NUMBER(18,2) NULL,
	"D3" NUMBER(18,2) NULL,
	"D4" NUMBER(18,2) NULL,
	"D5" NUMBER(18,2) NULL,
	"D6" NUMBER(18,2) NULL,
	"D7" NUMBER(18) NULL,
	"D8" NUMBER(18) NULL,
	"D9" NUMBER(18) NULL,
	"D10" NUMBER(18) NULL,
	"D11" NUMBER(18) NULL,
	"D12" NUMBER(18) NULL,
	"D13" NUMBER(18) NULL,
	"D14" TIMESTAMP(6) NULL,
	"D15" TIMESTAMP(6) NULL,
	"D16" VARCHAR2(255) NULL,
	"D17" VARCHAR2(255) NULL,
	"D18" VARCHAR2(255) NULL,
	"D19" VARCHAR2(255) NULL,
	"D20" VARCHAR2(255) NULL
)
;

/* Create Comments, Sequences and Triggers for Autonumber Columns */

COMMENT ON TABLE  "SDC_CMPL_AUDIT_LOG" IS 'Staging Table for Completeness Control Audits'
;

/* Create Primary Keys, Indexes, Uniques, Checks, Triggers */

CREATE INDEX "AUDIT_KEY_IDX"   
 ON  "SDC_CMPL_AUDIT_LOG" ("AUDIT_KEY") 
;

/* ---------------------------------------------------- */
/*  Generated by Enterprise Architect Version 13.5 		*/
/*  Created On : 20-Sep-2018 4:51:37 PM 				*/
/*  DBMS       : Oracle 						        */
/* ---------------------------------------------------- */

/* Drop Tables */

begin
	EXECUTE IMMEDIATE 'DROP TABLE   "SDC_FLEX_MEASURES" CASCADE CONSTRAINTS';
	EXCEPTION WHEN OTHERS THEN NULL;
end;  
/

/* Create Tables */

CREATE TABLE  "SDC_FLEX_MEASURES"
(
	"AUDIT_ID" VARCHAR2(50) NOT NULL,
	"DIMENSION_ID" VARCHAR2(3) NOT NULL,
	"MEASURE_NAME" VARCHAR2(255) NOT NULL,
	"MEASURE_DESC" VARCHAR2(255) NULL,
	"SEQ_ID" NUMBER(8) NULL
)
;

/* Create Primary Keys, Indexes, Uniques, Checks, Triggers */

ALTER TABLE  "SDC_FLEX_MEASURES" 
 ADD CONSTRAINT "PK_SDC_FLEX_MEASURES"
	PRIMARY KEY ("AUDIT_ID","DIMENSION_ID") 
 USING INDEX
;

/* ---------------------------------------------------- */
/*  Generated by Enterprise Architect Version 13.5 		*/
/*  Created On : 20-Sep-2018 4:35:35 PM 				*/
/*  DBMS       : Oracle 						        */
/* ---------------------------------------------------- */

/* Drop Tables */

begin
	EXECUTE IMMEDIATE 'DROP TABLE   "SDC_CA_SOURCES" CASCADE CONSTRAINTS';
	EXCEPTION WHEN OTHERS THEN NULL;
end;  
/

/* Create Tables */

CREATE TABLE  "SDC_CA_SOURCES"
(
	"AUDIT_ID" VARCHAR2(50) NOT NULL,
	"SOURCE_NAME" VARCHAR2(255) NOT NULL,
	"CTYPE" VARCHAR2(10) NOT NULL,
	"DATA_SET_NAME" VARCHAR2(255) NULL,
	"SOURCE_NARID" VARCHAR2(50) NULL,
	"TARGET_NARID" VARCHAR2(50) NOT NULL,
	"GROUP_NAME" VARCHAR2(50) NOT NULL,
	"INSTANCE_NAME" VARCHAR2(50) NOT NULL,
	"JURISDICTION" VARCHAR2(10) NOT NULL,
	"DATA_FREQUENCY" VARCHAR2(10) NOT NULL,
	"DATA_TRANSPORT" VARCHAR2(10) NOT NULL,
	"DATA_TEMPLATE" VARCHAR2(100) NOT NULL,
	"API_KEY" VARCHAR2(255) NOT NULL,
	"CREATOR" VARCHAR2(30) NULL,
	"CREATED_ON" TIMESTAMP(6) NULL
)
;

/* Create Primary Keys, Indexes, Uniques, Checks, Triggers */

ALTER TABLE  "SDC_CA_SOURCES" 
 ADD CONSTRAINT "PK_SDC_CA_SOURCES"
	PRIMARY KEY ("AUDIT_ID") 
 USING INDEX
;

/* ---------------------------------------------------- */
/*  Generated by Enterprise Architect Version 13.5 		*/
/*  Created On : 14-Sep-2018 1:38:49 PM 				*/
/*  DBMS       : Oracle 						        */
/* ---------------------------------------------------- */

/* Drop Tables */

begin
	EXECUTE IMMEDIATE 'DROP TABLE   "SDC_CA_ACL" CASCADE CONSTRAINTS';
	EXCEPTION WHEN OTHERS THEN NULL;
end;  
/

/* Create Tables */

CREATE TABLE  "SDC_CA_ACL"
(
	"USER_ID" VARCHAR2(30) NOT NULL,
	"GROUP_NAME" VARCHAR2(50) NOT NULL,
	"USER_NAME" VARCHAR2(50) NULL,
	"ORG_UNIT" VARCHAR2(255) NULL,
	"PERMISSION" VARCHAR2(3) NULL
)
;

/* Create Primary Keys, Indexes, Uniques, Checks, Triggers */

ALTER TABLE  "SDC_CA_ACL" 
 ADD CONSTRAINT "PK_SDC_CA_ACL"
	PRIMARY KEY ("USER_ID") 
 USING INDEX
;

/* ---------------------------------------------------- */
/*  Generated by Enterprise Architect Version 13.5 		*/
/*  Created On : 17-Sep-2018 3:15:56 PM 				*/
/*  DBMS       : Oracle 						*/
/* ---------------------------------------------------- */

/* Drop Tables */

begin
	EXECUTE IMMEDIATE 'DROP TABLE   "SDC_CA_CODES" CASCADE CONSTRAINTS';
	EXCEPTION WHEN OTHERS THEN NULL;
end;  
/

/* Create Tables */

CREATE TABLE  "SDC_CA_CODES"
(
	"CODE" VARCHAR2(5) NOT NULL,
	"DESCRIPTION" VARCHAR2(30) NOT NULL,
	"TYPE" VARCHAR2(20) NULL
)
;
